package work.xuye.transformer.transformer;

import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

/**
 * @author xuye
 * @since 2023/2/18 13:01
 **/
@Slf4j
@Component("resData")
@RequiredArgsConstructor
public class ResDataTransformer implements MessageTransformer {
    
    private int threshold = 300;

    @Override
    public String transform(String json, String seedUrl) {
        JsonObject res = JsonParser.parseString(json).getAsJsonObject();
        boolean hasData = res.has("data");
        if (hasData) {
            threshold = 300;
        } else {
            threshold--;
        }
        if (threshold <= 0) {
            throw new RuntimeException("res no data, seedUrl: " + seedUrl);
        }
        return res.get("data").getAsString();
    }

}
